@echo off
cls
if not exist "%~dp0config.ini" (
	echo unlock_region=false>>"%~dp0config.ini"
	echo remove_logo=false>>"%~dp0config.ini"
	echo remove_plain=false>>"%~dp0config.ini"
	echo show_output=false>>"%~dp0config.ini"
)
if "%~n1"=="" (
	echo Usage:
	echo citra-cxi-maker ^<main-file^> [^<update-file^>]
	echo citra-cxi-maker ^<main-folder^>
	pause >nul
	exit /b
)
if exist "%~f1\" (
	set batch=1
	for /f "usebackq delims=|" %%a in (`dir /b /s /a-d-h-s %1 ^| find /v /c ""`) do set total=%%a
	set count=0
	for /f "usebackq delims=|" %%a in (`dir /b /s /a-d-h-s %1`) do (
		set /a count+=1
		call "%~dpnx0" "%%a"
	)
	exit /b	
)
if not exist "%~f1\" (
	echo Citra CXI Maker v1.3 ^(2021-02-15^)
	echo by eqagunn
	echo.
	if "%batch%"=="1" (
		call echo %%time:~0,-3%% Processing job %%count%%/%%total%%.
	) else (
		call echo %%time:~0,-3%% Processing job 1/1.
	)
	call echo %%time:~0,-3%% Reading configuration file.
	for /f "usebackq delims=|" %%a in (`type "%~dp0config.ini"`) do set "%%a"
)
echo %time:~0,-3% MAIN: "%~nx1"
if not "%~n2"=="" echo %time:~0,-3% UPDATE: "%~nx2"
echo %time:~0,-3% Preparing MAIN temp folder.
if not exist "%~dp0temp\" md "%~dp0temp\"
if exist "%~dp0temp\%~nx1\" rd /s /q "%~dp0temp\%~nx1\"
md "%~dp0temp\%~nx1\"
echo %time:~0,-3% Setting cxi location for non-cxi input files.
set "ncch0a=%~dp0temp\%~nx1\ncch0.bin"
set "ncch0b=%~dp0temp\%~nx2\ncch0.bin"
echo %time:~0,-3% Checking MAIN input file format.
if /i "%~x1"==".cia" (
	call echo %%time:~0,-3%% Extracting cxi from MAIN cia.
	call "%~dp0tools\ctrtool.exe" --contents="%~dp0temp\%~nx1\ncch" %%1 >nul
	ren "%~dp0temp\%~nx1\ncch.0000.*" ncch0.bin
) else if /i "%~x1"==".3ds" (
	call echo %%time:~0,-3%% Extracting cxi from MAIN 3ds.
	call "%~dp0tools\3dstool.exe" -xtf cci %%1 -0 "%~dp0temp\%~nx1\ncch0.bin"
) else if /i "%~x1"==".cci" (
	call echo %%time:~0,-3%% Extracting cxi from MAIN cci.
	call "%~dp0tools\3dstool.exe" -xtf cci %%1 -0 "%~dp0temp\%~nx1\ncch0.bin"
) else if /i "%~x1"==".cxi" (
	call echo %%time:~0,-3%% Changing cxi location to MAIN input file.
	set "ncch0a=%~f1"
) else (
	call echo %%time:~0,-3%% MAIN file format not supported!
	rd /s /q "%~dp0temp\%~nx1\"
	if not "%batch%"=="1" pause >nul
	exit /b
)
echo %time:~0,-3% Extracting MAIN cxi contents to decrypt them.
"%~dp0tools\3dstool.exe" -xtf cxi "%ncch0a%" ^
--header "%~dp0temp\%~nx1\cxiheader.bin" ^
--exh "%~dp0temp\%~nx1\exh.bin" ^
--logo "%~dp0temp\%~nx1\logo.bin" ^
--plain "%~dp0temp\%~nx1\plain.bin" ^
--exefs "%~dp0temp\%~nx1\exefs.bin" ^
--romfs "%~dp0temp\%~nx1\romfs.bin"
echo %time:~0,-3% Extracting MAIN exefs contents to UPDATE them.
"%~dp0tools\3dstool.exe" -xtf exefs "%~dp0temp\%~nx1\exefs.bin" ^
--header "%~dp0temp\%~nx1\exefsheader.bin" ^
--exefs-dir "%~dp0temp\%~nx1\exefs"
if not "%~n2"=="" (
	call echo %%time:~0,-3%% Extracting MAIN romfs contents to UPDATE them.
	"%~dp0tools\3dstool.exe" -xtf romfs "%~dp0temp\%~nx1\romfs.bin" ^
	--header "%~dp0temp\%~nx1\romfsheader.bin" ^
	--romfs-dir "%~dp0temp\%~nx1\romfs"
	call echo %%time:~0,-3%% Preparing UPDATE temp folder.
	if exist "%~dp0temp\%~nx2\" rd /s /q "%~dp0temp\%~nx2\"
	md "%~dp0temp\%~nx2\"
	call echo %%time:~0,-3%% Checking UPDATE input file format.
	if /i "%~x2"==".cia" (
		call echo %%time:~0,-3%% Extracting cxi from UPDATE cia.
		call "%~dp0tools\ctrtool.exe" --contents="%~dp0temp\%~nx2\ncch" %%2 >nul
		ren "%~dp0temp\%~nx2\ncch.0000.*" ncch0.bin
	) else if /i "%~x2"==".3ds" (
		call echo %%time:~0,-3%% Extracting cxi from UPDATE 3ds.
		call "%~dp0tools\3dstool.exe" -xtf cci %%2 -0 "%~dp0temp\%~nx2\ncch0.bin"
	) else if /i "%~x2"==".cci" (
		call echo %%time:~0,-3%% Extracting cxi from UPDATE cci.
		call "%~dp0tools\3dstool.exe" -xtf cci %%2 -0 "%~dp0temp\%~nx2\ncch0.bin"
	) else if /i "%~x2"==".cxi" (
		call echo %%time:~0,-3%% Changing cxi location to UPDATE input file.
		set "ncch0b=%~f2"
	) else (
		call echo %%time:~0,-3%% UPDATE file format not supported!
		rd /s /q "%~dp0temp\%~nx2\"
		if not %%batch%%==1 pause >nul
		exit /b
	)
	call echo %%time:~0,-3%% Extracting required UPDATE cxi contents and overwriting MAIN exh.
	call "%~dp0tools\3dstool.exe" -xtf cxi "%%ncch0b%%" ^
	--exh "%~dp0temp\%~nx1\exh.bin" ^
	--exefs "%~dp0temp\%~nx2\exefs.bin" ^
	--romfs "%~dp0temp\%~nx2\romfs.bin"
	call echo %%time:~0,-3%% Extracting UPDATE exefs contents and overwriting MAIN ones.
	"%~dp0tools\3dstool.exe" -xtf exefs "%~dp0temp\%~nx2\exefs.bin" ^
	--exefs-dir "%~dp0temp\%~nx1\exefs"
	call echo %%time:~0,-3%% Extracting UPDATE romfs contents and overwriting MAIN ones.
	"%~dp0tools\3dstool.exe" -xtf romfs "%~dp0temp\%~nx2\romfs.bin" ^
	--romfs-dir "%~dp0temp\%~nx1\romfs"
	call echo %%time:~0,-3%% Removing UPDATE temp folder.
	rd /s /q "%~dp0temp\%~nx2"
	call echo %%time:~0,-3%% Recreating MAIN romfs.
	"%~dp0tools\3dstool.exe" -ctf romfs "%~dp0temp\%~nx1\romfs.bin" ^
	--header "%~dp0temp\%~nx1\romfsheader.bin" ^
	--romfs-dir "%~dp0temp\%~nx1\romfs"
)
if "%unlock_region%"=="true" (
	call echo %time:~0,-3% Unlocking region in MAIN icon.
	echo 00002018: ffff ff7f | "%~dp0tools\xxd.exe" -r - "%~dp0temp\%~nx1\exefs\icon.icn"
) else (
	call echo %time:~0,-3% Retaining region lock in MAIN icon.
)
echo %time:~0,-3% Recreating MAIN exefs.
"%~dp0tools\3dstool.exe" -ctf exefs "%~dp0temp\%~nx1\exefs.bin" ^
--header "%~dp0temp\%~nx1\exefsheader.bin" ^
--exefs-dir "%~dp0temp\%~nx1\exefs"
echo %time:~0,-3% Recreating MAIN cxi without encrypting.
if not exist "%~dp0output\" md "%~dp0output\"
if "%remove_logo%"=="true" (
	if "%remove_plain%"=="true" (
		call echo %time:~0,-3% Excluding both logo and plain regions from MAIN cxi.
		"%~dp0tools\3dstool.exe" -ctf cxi "%~dp0output\%~n1.cxi" --not-encrypt ^
		--header "%~dp0temp\%~nx1\cxiheader.bin" ^
		--exh "%~dp0temp\%~nx1\exh.bin" ^
		--exefs "%~dp0temp\%~nx1\exefs.bin" ^
		--romfs "%~dp0temp\%~nx1\romfs.bin"
	) else (
		if exist "%~dp0temp\%~nx1\plain.bin" (
			call echo %time:~0,-3% Excluding logo region from MAIN cxi, but including plain.
			"%~dp0tools\3dstool.exe" -ctf cxi "%~dp0output\%~n1.cxi" --not-encrypt ^
			--header "%~dp0temp\%~nx1\cxiheader.bin" ^
			--exh "%~dp0temp\%~nx1\exh.bin" ^
			--plain "%~dp0temp\%~nx1\plain.bin" ^
			--exefs "%~dp0temp\%~nx1\exefs.bin" ^
			--romfs "%~dp0temp\%~nx1\romfs.bin"
		) else (
			call echo %time:~0,-3% Excluding logo region from MAIN cxi, plain was not present.
			"%~dp0tools\3dstool.exe" -ctf cxi "%~dp0output\%~n1.cxi" --not-encrypt ^
			--header "%~dp0temp\%~nx1\cxiheader.bin" ^
			--exh "%~dp0temp\%~nx1\exh.bin" ^
			--exefs "%~dp0temp\%~nx1\exefs.bin" ^
			--romfs "%~dp0temp\%~nx1\romfs.bin"
		)
	)
) else (
	if "%remove_plain%"=="true" (
		if exist "%~dp0temp\%~nx1\logo.bin" (
			call echo %time:~0,-3% Including logo region in MAIN cxi, but excluding plain.
			"%~dp0tools\3dstool.exe" -ctf cxi "%~dp0output\%~n1.cxi" --not-encrypt ^
			--header "%~dp0temp\%~nx1\cxiheader.bin" ^
			--exh "%~dp0temp\%~nx1\exh.bin" ^
			--logo "%~dp0temp\%~nx1\logo.bin" ^
			--exefs "%~dp0temp\%~nx1\exefs.bin" ^
			--romfs "%~dp0temp\%~nx1\romfs.bin"
		) else (
			call echo %time:~0,-3% Logo region was not present, excluding plain from MAIN cxi.
			"%~dp0tools\3dstool.exe" -ctf cxi "%~dp0output\%~n1.cxi" --not-encrypt ^
			--header "%~dp0temp\%~nx1\cxiheader.bin" ^
			--exh "%~dp0temp\%~nx1\exh.bin" ^
			--exefs "%~dp0temp\%~nx1\exefs.bin" ^
			--romfs "%~dp0temp\%~nx1\romfs.bin"
		)
	) else (
		if exist "%~dp0temp\%~nx1\logo.bin" (
			if exist "%~dp0temp\%~nx1\plain.bin" (
				call echo %time:~0,-3% Including both logo and plain regions in MAIN cxi.
				"%~dp0tools\3dstool.exe" -ctf cxi "%~dp0output\%~n1.cxi" --not-encrypt ^
				--header "%~dp0temp\%~nx1\cxiheader.bin" ^
				--exh "%~dp0temp\%~nx1\exh.bin" ^
				--logo "%~dp0temp\%~nx1\logo.bin" ^
				--plain "%~dp0temp\%~nx1\plain.bin" ^
				--exefs "%~dp0temp\%~nx1\exefs.bin" ^
				--romfs "%~dp0temp\%~nx1\romfs.bin"
			) else (
				call echo %time:~0,-3% Including logo region in MAIN cxi, but plain was not present.
				"%~dp0tools\3dstool.exe" -ctf cxi "%~dp0output\%~n1.cxi" --not-encrypt ^
				--header "%~dp0temp\%~nx1\cxiheader.bin" ^
				--exh "%~dp0temp\%~nx1\exh.bin" ^
				--logo "%~dp0temp\%~nx1\logo.bin" ^
				--exefs "%~dp0temp\%~nx1\exefs.bin" ^
				--romfs "%~dp0temp\%~nx1\romfs.bin"
			)
		) else (
			if exist "%~dp0temp\%~nx1\plain.bin" (
				call echo %time:~0,-3% Logo region was not present, but including plain in MAIN cxi.
				"%~dp0tools\3dstool.exe" -ctf cxi "%~dp0output\%~n1.cxi" --not-encrypt ^
				--header "%~dp0temp\%~nx1\cxiheader.bin" ^
				--exh "%~dp0temp\%~nx1\exh.bin" ^
				--plain "%~dp0temp\%~nx1\plain.bin" ^
				--exefs "%~dp0temp\%~nx1\exefs.bin" ^
				--romfs "%~dp0temp\%~nx1\romfs.bin"
			) else (
				call echo %time:~0,-3% Both logo and plain regions were not present.
				"%~dp0tools\3dstool.exe" -ctf cxi "%~dp0output\%~n1.cxi" --not-encrypt ^
				--header "%~dp0temp\%~nx1\cxiheader.bin" ^
				--exh "%~dp0temp\%~nx1\exh.bin" ^
				--exefs "%~dp0temp\%~nx1\exefs.bin" ^
				--romfs "%~dp0temp\%~nx1\romfs.bin"
			)
		)
	)
)
echo %time:~0,-3% "%~n1.cxi" ready!
echo %time:~0,-3% Removing MAIN temp folder.
rd /s /q "%~dp0temp\%~nx1"
echo %time:~0,-3% Done!
if not "%batch%"=="" (
	if "%count%"=="%total%" set "batch="
)
if "%batch%"=="" (
	pause >nul
	if "%show_output%"=="true" call "%systemroot%\explorer.exe" "%~dp0output\"
)
exit /b
